unit Jog;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Buttons, StdCtrls, DeskWinApi, DeskWinCNC;

type
  TFormJog = class(TForm)
    GroupBoxJogControl: TGroupBox;
    ButtonJogAMinus: TButton;
    ButtonJogAPlus: TButton;
    ButtonJogZMinus: TButton;
    ButtonJogZPlus: TButton;
    ButtonJogXMinus: TButton;
    ButtonJogYMinus: TButton;
    ButtonJogYPlus: TButton;
    ButtonJogXPlus: TButton;
    ButtonAMinus1: TButton;
    ButtonAPlus1: TButton;
    ButtonZMinus1: TButton;
    ButtonZPlus1: TButton;
    ButtonYMinus1: TButton;
    ButtonYPlus1: TButton;
    ButtonXMinus1: TButton;
    ButtonXPlus1: TButton;
    ButtonAMinus10: TButton;
    ButtonAPlus10: TButton;
    ButtonZMinus10: TButton;
    ButtonZPlus10: TButton;
    ButtonYMinus10: TButton;
    ButtonYPlus10: TButton;
    ButtonXMinus10: TButton;
    ButtonXPlus10: TButton;
    GroupBoxPosition: TGroupBox;
    LabelStatus: TLabel;
    LabelX: TLabel;
    LabelY: TLabel;
    LabelZ: TLabel;
    LabelA: TLabel;
    BitBtn1: TBitBtn;
    procedure ButtonXPlus10Click(Sender: TObject);
    procedure ButtonXPlus1Click(Sender: TObject);
    procedure ButtonJogXPlusClick(Sender: TObject);
    procedure ButtonJogXMinusClick(Sender: TObject);
    procedure ButtonXMinus1Click(Sender: TObject);
    procedure ButtonXMinus10Click(Sender: TObject);
    procedure ButtonYPlus10Click(Sender: TObject);
    procedure ButtonYPlus1Click(Sender: TObject);
    procedure ButtonJogYPlusClick(Sender: TObject);
    procedure ButtonJogYMinusClick(Sender: TObject);
    procedure ButtonYMinus1Click(Sender: TObject);
    procedure ButtonYMinus10Click(Sender: TObject);
    procedure ButtonZPlus10Click(Sender: TObject);
    procedure ButtonZPlus1Click(Sender: TObject);
    procedure ButtonJogZPlusClick(Sender: TObject);
    procedure ButtonJogZMinusClick(Sender: TObject);
    procedure ButtonZMinus1Click(Sender: TObject);
    procedure ButtonZMinus10Click(Sender: TObject);
    procedure ButtonAPlus10Click(Sender: TObject);
    procedure ButtonAPlus1Click(Sender: TObject);
    procedure ButtonJogAPlusClick(Sender: TObject);
    procedure ButtonJogAMinusClick(Sender: TObject);
    procedure ButtonAMinus1Click(Sender: TObject);
    procedure ButtonAMinus10Click(Sender: TObject);
  private
    { Private declarations }
    Procedure UpdateStatus;
  public
    { Public declarations }
  end;

var
  FormJog: TFormJog;

implementation

{$R *.dfm}


procedure TFormJog.ButtonXPlus1Click(Sender: TObject);
begin
  JogX := 1;
  JogY := 0;
  JogZ := 0;
  JogA := 0;
  Jog;
  UpdateStatus;
end;

procedure TFormJog.ButtonYMinus10Click(Sender: TObject);
begin
  JogX := 0;
  JogY := -10;
  JogZ := 0;
  JogA := 0;
  Jog;
  UpdateStatus;
end;

procedure TFormJog.ButtonYMinus1Click(Sender: TObject);
begin
  JogX := 0;
  JogY := -1;
  JogZ := 0;
  JogA := 0;
  Jog;
  UpdateStatus;
end;

procedure TFormJog.ButtonYPlus10Click(Sender: TObject);
begin
  JogX := 0;
  JogY := 10;
  JogZ := 0;
  JogA := 0;
  Jog;
  UpdateStatus;
end;

procedure TFormJog.ButtonYPlus1Click(Sender: TObject);
begin
  JogX := 0;
  JogY := 1;
  JogZ := 0;
  JogA := 0;
  Jog;
  UpdateStatus;
end;

procedure TFormJog.ButtonZMinus10Click(Sender: TObject);
begin
  JogX := 0;
  JogY := 0;
  JogZ := -10;
  JogA := 0;
  Jog;
  UpdateStatus;
end;

procedure TFormJog.ButtonZMinus1Click(Sender: TObject);
begin
  JogX := 0;
  JogY := 0;
  JogZ := -1;
  JogA := 0;
  Jog;
  UpdateStatus;
end;

procedure TFormJog.ButtonZPlus10Click(Sender: TObject);
begin
  JogX := 0;
  JogY := 0;
  JogZ := 10;
  JogA := 0;
  Jog;
  UpdateStatus;
end;

procedure TFormJog.ButtonZPlus1Click(Sender: TObject);
begin
  JogX := 0;
  JogY := 0;
  JogZ := 1;
  JogA := 0;
  Jog;
  UpdateStatus;
end;

Procedure TFormJog.UpdateStatus;
begin
  if CNCControllerFound and Initialised then
    LabelStatus.Caption := 'STATUS ' + IntToStr(Status)
  else
    LabelStatus.Caption := 'NOT ACTIVE';

  LabelX.Caption := 'X ' + FloatToStrF(XPos, ffFixed, 10, 3);
  LabelY.Caption := 'Y ' + FloatToStrF(YPos, ffFixed, 10, 3);
  LabelZ.Caption := 'Z ' + FloatToStrF(ZPos, ffFixed, 10, 3);
  LabelA.Caption := 'A ' + FloatToStrF(APos, ffFixed, 10, 3);
end;

procedure TFormJog.ButtonAMinus10Click(Sender: TObject);
begin
  JogX := 0;
  JogY := 0;
  JogZ := 0;
  JogA := -10;
  Jog;
  UpdateStatus;
end;

procedure TFormJog.ButtonAMinus1Click(Sender: TObject);
begin
  JogX := 0;
  JogY := 0;
  JogZ := 0;
  JogA := -10;
  Jog;
  UpdateStatus;
end;

procedure TFormJog.ButtonAPlus10Click(Sender: TObject);
begin
  JogX := 0;
  JogY := 0;
  JogZ := 0;
  JogA := 10;
  Jog;
  UpdateStatus;
end;

procedure TFormJog.ButtonAPlus1Click(Sender: TObject);
begin
  JogX := 0;
  JogY := 0;
  JogZ := 0;
  JogA := 1;
  Jog;
  UpdateStatus;
end;

procedure TFormJog.ButtonJogAMinusClick(Sender: TObject);
begin
  JogX := 0;
  JogY := 0;
  JogZ := 0;
  JogA := -1 / CNCAStepsPerRev * 360;
  Jog;
  UpdateStatus;
end;

procedure TFormJog.ButtonJogAPlusClick(Sender: TObject);
begin
  JogX := 0;
  JogY := 0;
  JogZ := 0;
  JogA := 1 / CNCAStepsPerRev * 360;
  Jog;
  UpdateStatus;
end;

procedure TFormJog.ButtonJogXMinusClick(Sender: TObject);
begin
  JogX := -1 / CNCXStepsPerMM;
  JogY := 0;
  JogZ := 0;
  JogA := 0;
  Jog;
  UpdateStatus;
end;

procedure TFormJog.ButtonJogXPlusClick(Sender: TObject);
begin
  JogX := 1 / CNCXStepsPerMM;
  JogY := 0;
  JogZ := 0;
  JogA := 0;
  Jog;
  UpdateStatus;
end;

procedure TFormJog.ButtonJogYMinusClick(Sender: TObject);
begin
  JogX := 0;
  JogY := -1 / CNCYStepsPerMM;
  JogZ := 0;
  JogA := 0;
  Jog;
  UpdateStatus;
end;

procedure TFormJog.ButtonJogYPlusClick(Sender: TObject);
begin
  JogX := 0;
  JogY := 1 / CNCYStepsPerMM;
  JogZ := 0;
  JogA := 0;
  Jog;
  UpdateStatus;
end;

procedure TFormJog.ButtonJogZMinusClick(Sender: TObject);
begin
  JogX := 0;
  JogY := 0;
  JogZ := -1 / CNCZStepsPerMM;
  JogA := 0;
  Jog;
  UpdateStatus;
end;

procedure TFormJog.ButtonJogZPlusClick(Sender: TObject);
begin
  JogX := 0;
  JogY := 0;
  JogZ := 1 / CNCZStepsPerMM;
  JogA := 0;
  Jog;
  UpdateStatus;
end;

procedure TFormJog.ButtonXMinus10Click(Sender: TObject);
begin
  JogX := -10;
  JogY := 0;
  JogZ := 0;
  JogA := 0;
  Jog;
  UpdateStatus;
end;

procedure TFormJog.ButtonXMinus1Click(Sender: TObject);
begin
  JogX := -1;
  JogY := 0;
  JogZ := 0;
  JogA := 0;
  Jog;
  UpdateStatus;
end;

procedure TFormJog.ButtonXPlus10Click(Sender: TObject);
begin
  JogX := 10;
  JogY := 0;
  JogZ := 0;
  JogA := 0;
  Jog;
  UpdateStatus;
end;

end.
