unit ConfirmNozzleSelection;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons;

type
  TFormConfirmNozzleSelection = class(TForm)
    GroupBox1: TGroupBox;
    RadioButtonNozzle1: TRadioButton;
    RadioButtonNozzle2: TRadioButton;
    RadioButtonNozzle3: TRadioButton;
    RadioButtonNozzle4: TRadioButton;
    RadioButtonNozzle5: TRadioButton;
    RadioButtonNozzle6: TRadioButton;
    RadioButtonNozzle7: TRadioButton;
    RadioButtonNozzle8: TRadioButton;
    ButtonOk: TBitBtn;
    RadioButtonNone: TRadioButton;
    procedure FormShow(Sender: TObject);
    procedure RadioButtonNozzle1Click(Sender: TObject);
    procedure RadioButtonNozzle2Click(Sender: TObject);
    procedure RadioButtonNozzle3Click(Sender: TObject);
    procedure RadioButtonNozzle4Click(Sender: TObject);
    procedure RadioButtonNozzle5Click(Sender: TObject);
    procedure RadioButtonNozzle6Click(Sender: TObject);
    procedure RadioButtonNozzle7Click(Sender: TObject);
    procedure RadioButtonNozzle8Click(Sender: TObject);
    procedure RadioButtonNoneClick(Sender: TObject);
  private
    { Private declarations }
    Enabled: boolean;
  public
    { Public declarations }
  end;

var
  FormConfirmNozzleSelection: TFormConfirmNozzleSelection;

implementation

{$R *.dfm}

uses
  Main, Settings;

procedure TFormConfirmNozzleSelection.FormShow(Sender: TObject);
begin
  Enabled := false;

  case CurrentNozzle of // set last known status
    1:
      RadioButtonNozzle1.Checked := true;
    2:
      RadioButtonNozzle2.Checked := true;
    3:
      RadioButtonNozzle3.Checked := true;
    4:
      RadioButtonNozzle4.Checked := true;
    5:
      RadioButtonNozzle5.Checked := true;
    6:
      RadioButtonNozzle6.Checked := true;
    7:
      RadioButtonNozzle7.Checked := true;
    8:
      RadioButtonNozzle8.Checked := true;
  else
    RadioButtonNone.Checked := true;
  end;

  Enabled := true;
end;

procedure TFormConfirmNozzleSelection.RadioButtonNoneClick(Sender: TObject);
begin
  CurrentNozzle := 0;
end;

procedure TFormConfirmNozzleSelection.RadioButtonNozzle1Click(Sender: TObject);
begin
  CurrentNozzle := 1;
end;

procedure TFormConfirmNozzleSelection.RadioButtonNozzle2Click(Sender: TObject);
begin
  CurrentNozzle := 2;
end;

procedure TFormConfirmNozzleSelection.RadioButtonNozzle3Click(Sender: TObject);
begin
  CurrentNozzle := 3;
end;

procedure TFormConfirmNozzleSelection.RadioButtonNozzle4Click(Sender: TObject);
begin
  CurrentNozzle := 4;
end;

procedure TFormConfirmNozzleSelection.RadioButtonNozzle5Click(Sender: TObject);
begin
  CurrentNozzle := 5;
end;

procedure TFormConfirmNozzleSelection.RadioButtonNozzle6Click(Sender: TObject);
begin
  CurrentNozzle := 6;
end;

procedure TFormConfirmNozzleSelection.RadioButtonNozzle7Click(Sender: TObject);
begin
  CurrentNozzle := 7;
end;

procedure TFormConfirmNozzleSelection.RadioButtonNozzle8Click(Sender: TObject);
begin
  CurrentNozzle := 8;
end;

end.
